'Thomas Watson, May 2003
'
if val(Version$)<4 then
    notice "Requires LB4."
    end
end if

GLOBAL vib:vib=1
GLOBAL vibon:vibon=1
GLOBAL freq
GLOBAL vibfreq
GLOBAL vibamp
GLOBAL length
GLOBAL samplerate
GLOBAL channels
GLOBAL bitspersample
GLOBAL filename$
    DIM ComboArray1$(3)
    ComboArray1$(1) = "11025"
    ComboArray1$(2) = "22050"
    ComboArray1$(3) = "44100"
    DIM ComboArray2$(2)
    ComboArray2$(1) = "8"
    ComboArray2$(2) = "16"
    DIM ComboArray3$(2)
    ComboArray3$(1) = "1"
    ComboArray3$(2) = "2"

[WindowSetup]
    NOMAINWIN
    WindowWidth = 578 : WindowHeight = 272
    UpperLeftX = INT((DisplayWidth-WindowWidth)/2)
    UpperLeftY = INT((DisplayHeight-WindowHeight)/2)

[ControlSetup]

groupbox    #m.groupbox1, "Tone", 295, 0, 255, 210
statictext  #m.statictext1, "Filename:", 65, 10, 60, 16
statictext  #m.statictext2, "Length (seconds):", 15, 45, 110, 16
statictext  #m.statictext3, "Sample Rate:", 40, 80, 85, 16
statictext  #m.statictext4, "Bits Per Sample:", 20, 115, 105, 16
statictext  #m.statictext5, "Channels:", 60, 150, 65, 16
statictext  #m.statictext6, "Frequency:", 315, 25, 70, 16
statictext  #m.statictext7, "Frequency:", 315, 120, 70, 20
statictext  #m.statictext8, "Amplitude:", 320, 165, 65, 20
button      #m.btnGen, "Generate Wave",[GenerateWave],UL, 10, 185, 130, 25
button      #m.btnExit, "Exit",[Exit],UL, 150, 185, 130, 25
textbox     #m.txtFile, 135, 10, 137, 24
textbox     #m.txtLength, 135, 45, 137, 24
textbox     #m.txtFreq, 395, 25, 137, 24
textbox     #m.txtVibFreq, 395, 120, 137, 24
textbox     #m.txtVibAmp, 395, 165, 137, 24
radiobutton #m.radPitch, "Pitch",[radiobutton1.click],[loop], 395, 75, 55, 20
radiobutton #m.radInt, "Intensity",[radiobutton2.click],[loop], 465, 75, 70, 20
checkbox    #m.chkVib, "Vibrato",[checkbox1.click],[checkbox1.reset], 315, 75, 75, 20
combobox    #m.cmbRate,ComboArray1$(,[combobox1.click], 135, 80, 142, 300
combobox    #m.cmbBits,ComboArray2$(,[combobox2.click], 135, 115, 142, 300
combobox    #m.cmbChan,ComboArray3$(,[combobox3.click], 135, 150, 142, 300

Open "Tone Generator" for Window_nf as #m

    print #m, "trapclose [quit]"
    print #m, "font ms_sans_serif 10"
    print #m.radPitch, "set"
    print #m.cmbRate, "selectindex 1"
    print #m.cmbBits, "selectindex 1"
    print #m.cmbChan, "selectindex 1"
    print #m.txtFile, "test.wav"
    print #m.txtLength, "3"
    print #m.txtFreq, "1000"
    print #m.txtVibFreq, "4"
    print #m.txtVibAmp, "15"
    print #m.chkVib, "set"

    '** Change statusbar message at any time with sub ChangeStatusText
    hStatus = MakeStatusBar(HWND(#m), "")

    print #m, "resizehandler [ResizeStatus]"
[loop]
    Wait

[quit]
    close #m : END

[GenerateWave]
    call ChangeStatusText hStatus,0,"Generating wave..."
    print #m.txtFile, "!contents? filename$"
        if filename$="" then filename$="test.wav"
        if right$(lower$(filename$),4)<>".wav" then filename$=filename$+".wav"
        filename$=DefaultDir$+"\"+filename$
    print #m.txtLength, "!contents? stupid$":length=val(stupid$)
    print #m.cmbRate, "selection? stupid$":samplerate=val(stupid$)
    print #m.cmbBits, "selection? stupid$":bitspersample=val(stupid$)
    print #m.cmbChan, "selection? stupid$":channels=val(stupid$)
    if (samplerate<>11025) and (samplerate<>22050) and (samplerate<>44100) then samplerate=11025
    if (bitspersample<>8) and (bitspersample<>16) then bitspersample=8
    if (channels<>1) and (channels<>2) then channels=1

    print #m.txtFreq, "!contents? stupid$":freq=val(stupid$)
    print #m.txtVibFreq, "!contents? stupid$":vibfreq=val(stupid$)
    print #m.txtVibAmp, "!contents? stupid$":vibamp=val(stupid$)

    if (length<=0) or (freq<=0) or ((vibon=1) and (vibfreq<=0)) or ((vibon=1) and (vib=1) and ((vibamp>=freq) or (vibamp<=0))) or ((vibon=1) and (vib=2) and ((vibamp>63) or (vibamp<=0))) then
        notice "Uh oh!"
        wait
    end if

    gosub [makedawave]
    call ChangeStatusText hStatus,0,"Done!"
    playwave filename$
    wait

[Exit]
    goto [quit]

[radiobutton1.click]
    vib=1
    goto [loop]

[radiobutton2.click]
    vib=2
    goto [loop]

[checkbox1.click]
    vibon=1
    goto [loop]

[checkbox1.reset]
    vibon=0
    goto [loop]

[combobox1.click]
    print #m.cmbRate, "selection? selected$"
    goto [loop]

[combobox2.click]
    print #m.cmbBits, "selection? selected$"
    goto [loop]

[combobox3.click]
    print #m.cmbChan, "selection? selected$"
    goto [loop]

[ResizeStatus] 'resize status bar when window is resized
    SB.SETPARTS = 1028
    struct prt,edge1 as long
    'change measurements below as needed:
    sizePanel = Int(WindowWidth/1) 'divide WindowWidth by number of panels
    prt.edge1.struct = -1
    numParts = 1
    calldll #user32,  "SendMessageA", hStatus as long, SB.SETPARTS as long, numParts As Long, prt As struct, r As Long
    calldll #user32, "SendMessageA", hStatus as long, _WM_SIZE as long, 0 as long, WindowWidth as long, re as long
    goto [loop]

FUNCTION MakeStatusBar(hWin, caption$)
    style = _WS_VISIBLE or _WS_CHILD
    calldll #comctl32,"InitCommonControls", re as void
    calldll #comctl32,"CreateStatusWindow", style as long, caption$ as ptr, hWin as long, 22 as long, hBar as long

    '** Replace text in following lines with desired captions for panels:
    Call ChangeStatusText hBar, 0, "Statusbar"
    MakeStatusBar = hBar
    END FUNCTION

SUB ChangeStatusText hBar, panelID, newText$
    'use this sub to update captions on statusbar
    SB.SETTEXT = 1025
    calldll #user32, "SendMessageA", hBar as long, SB.SETTEXT as long, panelID as long, newText$ as ptr, re as long
    END SUB


[makedawave]
OPEN filename$ FOR OUTPUT AS #1
CLOSE #1

OPEN filename$ FOR BINARY AS #1
dat$ = "RIFF" + littleendian$(ascii$(length * samplerate * channels * bitspersample / 8 + 36, 4)): PRINT #1, dat$
dat$ = "WAVEfmt " + littleendian$(ascii$(16, 4)) + littleendian$(ascii$(1, 2)) + littleendian$(ascii$(channels, 2)): PRINT #1, dat$
dat$ = littleendian$(ascii$(samplerate, 4)) + littleendian$(ascii$(samplerate * bitspersample / 8, 4)): PRINT #1, dat$
dat$ = littleendian$(ascii$(channels * bitspersample / 8, 2)) + littleendian$(ascii$(bitspersample, 2)): PRINT #1, dat$
dat$ = "data" + littleendian$(ascii$(length * samplerate * channels * bitspersample / 8, 4)): PRINT #1, dat$

lastnum1 = 0
lastnum2 = 0
FOR i = 1 TO length * samplerate * bitspersample * channels / 8
select case
case (vibon=0)
    num = SIN(soundbyte(freq, lastnum1))
    dat$ = CHR$(127 * num + 127)
case (vibon=1) and (vib=1)
    num = SIN(soundbyte(freq + vibamp * SIN(soundbyte(vibfreq,lastnum2)), lastnum1))
    dat$ = CHR$(127 * num + 128)
case (vibon=1) and (vib=2)
    num = SIN(soundbyte(freq, lastnum1))
    num2 = SIN(soundbyte(freq + vibfreq, lastnum2))
    dat$ = CHR$((127 - vibamp) * num + vibamp * num2 + 128)
end select

dat$ = CHR$(120 * num + 7 * num2 + 128)
PRINT #1, dat$
NEXT i

CLOSE #1
RETURN

FUNCTION ascii$(num, leng)
remain = num
b$ = ""
pow = 0
ascii$ = ""

WHILE pow <> 1
    a = remain
    pow = 1
    WHILE a > 255
        a = INT(remain / (256 ^ pow))
        pow = pow + 1
    WEND
    b$ = b$ + CHR$(a)
    remain = remain - (a * (256 ^ (pow - 1)))
WEND

WHILE LEN(b$) <> leng
b$ = CHR$(0) + b$
WEND

ascii$ = b$
END FUNCTION

FUNCTION littleendian$(st$)    'function to reverse byte order
res$ = ""
FOR i = LEN(st$) TO 1 STEP -1
res$ = res$ + MID$(st$, i, 1)
NEXT i
littleendian$ = res$
END FUNCTION

FUNCTION soundbyte(frequency, byref n)
o = (n / 2 / 3.14159265 * samplerate * bitspersample * channels / 8 / frequency + 1) * frequency / samplerate / bitspersample / channels * 8 * 2 * 3.14159265
soundbyte = o
n = o
END FUNCTION
